Trace = {}

function Trace:Player(userid,distance)
	_TraceLine(_PlayerGetShootPos(userid),_PlayerGetShootAng(userid),distance,userid)
end

function Trace:PlayerReturn(intU,intD,bRe) -- Example: Trace:Player:Return(1,9999,true) returns what we hit
	Trace:Player(intU,intD)
	if bRe then
		return _TraceGetEnt()
	else
		return _TraceEndPos()
	end
end

entNames = {} -- Table of entity names.
CurSequence = nil;

DyCi = {}
for i=1,_MaxPlayers() do
	DyCi[i] = {}
	DyCi[i].ghost = nil;
	DyCi[i].drawing = false;
	DyCi[i].ghosttype = nil;
	DyCi[i].cursel = nil;
end

function isValid(npctype)
	local formodel = _EntCreate(npctype)
	_EntSetPos(formodel,vector3(0,0,0));
	_EntSpawn(formodel)
	local themodel = _EntGetModel(formodel) -- To get the model of the npctype.
	_EntRemove(formodel)

	if themodel ~= "" then
		return true;
	else
		return false;
	end
end
	

function ghostDynamic(userid,npctype)
	Trace:Player(userid,9999)
	if _TraceHit() then
		local formodel = _EntCreate(npctype)
		_EntSetPos(formodel,vector3(0,0,0));
		_EntSpawn(formodel)
		local themodel = _EntGetModel(formodel)
		_EntRemove(formodel)

		local newProp = _EntCreate("prop_dynamic")
		_EntPrecacheModel(themodel)
		_EntSetKeyValue(newProp, "model", themodel)
		_EntSetPos(newProp, _TraceEndPos());
		_EntSetSolid(newProp, 0);
		_EntSetMoveType(newProp, 0)
		_EntSetCollisionGroup(newProp, 0)
		_EntSetKeyValue(newProp, "targetname", "ghostPreview");
		_EntSetKeyValue(newProp, "rendermode", "1");
		_EntSetKeyValue(newProp, "renderamt", "160");
		_EntSetKeyValue(newProp, "spawnflags", "527");
		_EntSpawn(newProp);
		DyCi[userid].ghost = newProp;
		DyCi[userid].ghosttype = npctype;
	end
end

function dynamicThink()
	for i=1,_MaxPlayers() do
		if DyCi[i].drawing then
			Trace:Player(i,9999)
			if _TraceHit() then
				_EntSetPos(DyCi[i].ghost,_TraceEndPos()) -- Update it for us.
			end
		end
	end
end
AddThinkFunction(dynamicThink)
	
function startDynamic(userid,npctype)
	if not DyCi[userid].drawing then
		if isValid(npctype) then
			ghostDynamic(userid,npctype)
			DyCi[userid].drawing = true;
		end
	end
end
CONCOMMAND("BYO_Character",startDynamic)
--chat.CONCOMMAND("xyz100l",startDynamic) -- For the menu, mon.

function keyPress(userid,key)
	if DyCi[userid].drawing then
		if key == IN_USE then
			DyCi[userid].drawing = false; -- Stop the ghost from moving once we get our location.
			local themodel = _EntGetModel(DyCi[userid].ghost)
			local thepos = _EntGetPos(DyCi[userid].ghost)
			local theang = _EntGetAngAngle(DyCi[userid].ghost)
			local thetype = _EntGetType(DyCi[userid].ghost)
			_EntRemove(DyCi[userid].ghost)
			DyCi[userid].ghost = nil;

			local thething = _EntCreate(DyCi[userid].ghosttype)
			--_EntSetKeyValue(thething,"model",themodel)
			_EntSetPos(thething,thepos)
			_EntSpawn(thething)
			_EntSetAngAngle(thething,theang)
			local nextName = table.getn(entNames)+1;
			_EntSetName(thething,"Dynamic"..nextName)
			table.insert(entNames,_EntGetName(thething))
			_PrintMessage(userid,3,"Dynamic spawned. Name is " .. _EntGetName(thething) .. " For animation manipulation.")
		end
	else
		if key == IN_USE then
			local ent = Trace:PlayerReturn(userid,9999,true)
			_EntFire(ent,"color","255 0 0",0)
			_EntFire(ent,"color","255 255 255",1)
			DyCi[userid].cursel = ent;
		end
	end
end
keyhook = HookEvent("eventKeyPressed",keyPress)

function timedThink()
	for i=1,_MaxPlayers() do
		if DyCi[i].drawing then
			if _PlayerIsKeyDown(i,IN_ATTACK) then
				local curang = _EntGetAngAngle(DyCi[i].ghost)
				local newang = vector3(curang.x,curang.y+1,curang.z)
				_EntSetAngAngle(DyCi[i].ghost,newang)
			end
		end
	end
end
thinktimer = AddTimer(0.05,0,timedThink)

function runAnimation(userid,sequence)
	if sequence == "" then
		_PrintMessage(userid,2,"List of Animations. Use the NUMBER!")
		_PrintMessage(userid,2,"Lean left - 338")
		_PrintMessage(userid,2,"Lean back - 341")
		_PrintMessage(userid,2,"Sit on ground - 344")
		_PrintMessage(userid,2,"Sit in chair - 347")
		_PrintMessage(userid,2,"Idle wait - 351")
	else
		sequence = tonumber(sequence)
		_EntSetActivity(DyCi[userid].cursel,sequence)
	end
end
CONCOMMAND("BYO_Animate",runAnimation)
				
				
			
		
	
	
